/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
NX.define('Nexus.clm.ComponentDetailView', {
  extend: 'Ext.Panel',
  requirejs: ['Nexus/clm', 'Nexus/healthcheck/HealthCheckUtil'],
  initComponent : function() {
    var self = this;

    var encodeQueryParameters = function() {
      var result = '?appId=' + encodeURIComponent(self.appId);
      if (self.hash) {
        result += '&hash=' + encodeURIComponent(self.hash);
      }
      if (self.component) {
        result += '&componentIdentifier=' + encodeURIComponent(JSON.stringify(self.component));
      } else if (self.gav) {
        result += '&groupId=' + encodeURIComponent(self.gav.groupId);
        result += '&artifactId=' + encodeURIComponent(self.gav.artifactId);
        result += '&version=' + encodeURIComponent(self.gav.version);
        if (self.gav.classifier) {
          result += '&classifier=' + encodeURIComponent(self.gav.classifier);
        }
        if (self.gav.extension) {
          result += '&extension=' + encodeURIComponent(self.gav.extension);
        }
      }
      return result;
    };
    
    Ext.apply(self, {
      cls: 'nx-clm-ComponentDetailView',
      border: false,
      layout: 'fit',
      items: [{
        xtype: 'iframepanel',
        loadMask: {
          msg: 'Loading Component Detail...'
        },
        fitToParent: true,
        defaultSrc: Nexus.clm.componentDetailContentResourcePath + '/viewdetails.html' + encodeQueryParameters()
      }]
    });
    
    self.constructor.superclass.initComponent.apply(self, arguments);
  }
});