/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global NX, Nexus, Ext, Sonatype*/
NX.define('Nexus.ssl.certificate.AddByPEM', {
  extend : 'Nexus.ssl.certificate.FetchCertificateView',
  xtype : 'ssl-add-by-pem',

  windowHeight : 300,
  defaultMsgIcon : 'add-by-pem',
  defaultMsg : 'Please paste a SSL certificate in PEM format.',
  layout : 'anchor',
  padding : 10,

  initComponent : function() {
    var self = this;
    self.items = [
      {
        xtype : 'textarea',
        name : 'pem',
        style : 'margin: 10px;',
        anchor : '100% -40',
        validator : function(value) {
          value = self.trim(value);
          if ( value && value.length > 0 ) {
            return true;
          }

          return "Please provide a PEM.";
        },
        listeners : {
          afterrender : {
            fn : function(cmp) {
              cmp.focus(false, 100);
            },
            single : true
          },
          invalid : function() {
            self.buttons[0].disable();
          },
          valid : function() {
            self.buttons[0].enable();
          }
        }
      }
    ];

    self.constructor.superclass.initComponent.apply(self, arguments);
  },

  fetchPEM : function() {
    this.showCertificate({pem : this.find('name', 'pem')[0].getValue()});
  }
});